/** @(#)example1.h Created on: <04-Nov-2003 19:50:59 Z4303>
 *  Last Time-stamp: <30-Nov-2003 11:17:46 Z4303>
 *
 *  \file example1.h
 *  \brief  Interface for logical I/O used in example1.c
 *
 */

/*lint -save -e755 -e756 Disable warning(s), this file only, global macro/typedef 'Symbol' (Location) not referenced */

#ifndef _EXAMPLE1_H_
#define _EXAMPLE1_H_ (1)

#ifdef  DEFINE_SPACE_EXAMPLE1_H
#define EXTERN_EXAMPLE1
#else
#define EXTERN_EXAMPLE1 extern
#endif

#include "compiler.h"
#include "hardware.h"

#if defined(__cplusplus) && __cplusplus
 extern "C" {
#endif

/* INPUT FUNCTIONS: */
void Example1_I_SW1_ASSERTED( void );
void Example1_I_SW2_ASSERTED( void );

/* OUTPUT ACTIONS: */
#define Example1_O_LED1_ASSERT() LED1_ASSERT();

/* AUTOMATON ENGINE: */
int Example1( void );

/* AUTOMATON RESET: */
int Example1_reset( void );

#if defined(__cplusplus) && __cplusplus
 }
#endif

#endif /* _EXAMPLE1_H_ */

/*lint -restore */
